using System.Collections.Generic;
using Microsoft.MediaCenter.Hosting;
using Microsoft.MediaCenter.UI;
using System;
using Playkanaler;
using System.Windows.Forms;

namespace Playkanaler
{

    public class EpView : View
    {
        public EpView()
        {
            this.ContentName = "LargeEpisodeItem";
            this.Name = "Large";
            ShowFocus = true;
            Height = 190;
            Width = 255;
            EndPadding = 450;
        }


    }
    public class ListView : View
    {
        public ListView()
        {
            this.ContentName = "ListItem";
            this.Name = "List";
            EndPadding = 500;
            ShowBackground = true;
        }


    }



    public class View
    {
        string name;
        string cn;
        int height;
        int width;
        int beginpadding;
        int endpadding;
        bool showfocus;
        bool showbg;

        public View()
        {
        }
        public View(string n, string cnn)
        {
            Name = n;
            ContentName = cnn;
        }
        public bool ShowBackground
        {
            get
            {
                return showbg;
            }
            set
            {
                showbg = value;
            }
        }
        public bool ShowFocus
        {
            get
            {
                return showfocus;
            }
            set
            {
                showfocus = value;
            }
        }
        public Size Size
        {
            get
            {

                return new Size(Width, Height);
            }

        }


        public int EndPadding
        {
            get
            {
                return endpadding;
            }
            set
            {
                endpadding = value;
            }
        }
        public int BeginPadding
        {
            get
            {
                return beginpadding;
            }
            set
            {
                beginpadding = value;
            }
        }


        public int Height
        {
            get
            {
                return height;
            }
            set
            {
                height = value;
            }
        }
        public int Width
        {
            get
            {
                return width;
            }
            set
            {
                width = value;
            }
        }
        public string Name
        {
            get
            {
                return name;
            }
            set
            {
                name = value;
            }
        }
        public string ContentName
        {
            get
            {
                return cn;
            }
            set
            {
                cn = value;
            }
        }

    }
    public enum FocusArea
    {
        TabBar,
        Gallery,
        NowPlaying,
        ViewMenu
    }

    public class Setting : ModelItem, IAddInModule, IAddInEntryPoint
    {
        private static HistoryOrientedPageSession s_session;

        public void Initialize(Dictionary<string, object> appInfo, Dictionary<string, object> entryPointInfo)
        {
                
            ScreenSaver.Disable();
        }

        public void Uninitialize()
        {
            ScreenSaver.Enable();
        }

        public void Launch(AddInHost host)
        {
            s_session = new HistoryOrientedPageSession();            
            Dictionary<string, object> ps = new Dictionary<string, object>();
            ps.Add("Setting", this);
            s_session.GoToPage("resx://Playkanaler/Playkanaler.Resources/Default#Default", ps);
        }
        

        View view;

        ArrayListDataSet views = new ArrayListDataSet();

        Popup popup;
        public Popup Popup
        {
            get
            {
                return popup;
            }
            set
            {
                popup = value;
                FirePropertyChanged("Popup");
            }
        }
        bool showPopup;
        public bool ShowPopup
        {
            get { return showPopup; }
            set
            {
                showPopup = value;
                FirePropertyChanged("ShowPopup");
            }
        }
        public bool Loaded = false;
        public Setting()
        {
            selectedTabIndex = -1;
            Popup = new Popup();
            // ShowPopup = true;
        }
        virtual public void Load()
        {
        }
        public bool IsLoaded { get; set; }

        bool barActive;

        FocusArea focusarea;

        string heading;// = "";


        bool press = false;

        string qs;// = "";
        public string Qs
        {
            get
            {
                return qs;
            }
            set
            {
                qs = value;
                FirePropertyChanged("Qs");
            }
        }

        bool iswidescreen;
        public bool IsWidescreen { get { return iswidescreen; } set { iswidescreen = value; } }
        ArrayListDataSet tabs;//=new ArrayListDataSet();

        int selectedTabIndex = 0;

        Item selectedItem;

        public bool Press
        {
            get { return press; }
            set
            {
               
                press = value;
                FirePropertyChanged("Press");
            }
        }

        public FocusArea FocusArea
        {
            get { return focusarea; }
            set
            {
                focusarea = value;
                FirePropertyChanged("FocusArea");
            }
        }


        public string Heading
        {
            get { return heading; }
            set
            {
                heading = value;
                FirePropertyChanged("Heading");
            }
        }

        public Item SelectedItem
        {
            get { return selectedItem; }
            set
            {
                selectedItem = value;
                FirePropertyChanged("SelectedItem");
            }
        }
        public Tab SelectedTab
        {
            get
            {
                Tab Tab1 = (Tab)Tabs[selectedTabIndex];
                Tab1.Load();
                return Tab1;//(Tab)Tabs[selectedTabIndex]; 
            }
        }
        public virtual void Play(string url)
        {
            
            Settings.WriteReg("lasturl", url);
            if (url.StartsWith("rtmp://") || url.StartsWith("rtmpe://") || url.EndsWith(".flv"))
            {
                if (!((bool)Microsoft.MediaCenter.Hosting.AddInHost.Current.MediaCenterEnvironment.Capabilities["console"])) //extender
                {
                    Microsoft.MediaCenter.Hosting.AddInHost.Current.MediaCenterEnvironment.Dialog("Detta klippet kan inte spelas upp p en Extender.", "Kan inte spela upp", Microsoft.MediaCenter.DialogButtons.Ok, 0, true);
                    return;
                }
                string pa = @"file://" + Settings.Path + "player43.html?";
                if (IsWidescreen) pa = @"file://" + Settings.Path + "player169.html?";
                pa += url;
                try
                {
                    Microsoft.MediaCenter.Hosting.AddInHost.Current.MediaCenterEnvironment.MediaExperience.Transport.PlayRate = 0;
                }
                catch (Exception)
                {
                }
                Microsoft.MediaCenter.Hosting.AddInHost.Current.MediaCenterEnvironment.NavigateToPage(Microsoft.MediaCenter.PageId.ExtensibilityUrl, pa);
            }
            else
            {
                Microsoft.MediaCenter.Hosting.AddInHost.Current.MediaCenterEnvironment.PlayMedia(Microsoft.MediaCenter.MediaType.Video, url, false);
                Microsoft.MediaCenter.Hosting.AddInHost.Current.MediaCenterEnvironment.MediaExperience.GoToFullScreen();
            }

        }
        public static void Navigate(Setting set)
        {
            Dictionary<string, object> ps = new Dictionary<string, object>();
            ps.Add("Setting", set);
            Microsoft.MediaCenter.Hosting.PageSession.Current.GoToPage("resx://Playkanaler/Playkanaler.Resources/Default#Default", ps);
        }
        public void Navigate()
        {
            Dictionary<string, object> ps = new Dictionary<string, object>();
            ps.Add("Setting", this);
            Microsoft.MediaCenter.Hosting.PageSession.Current.GoToPage("resx://Playkanaler/Playkanaler.Resources/Default#Default", ps);
        }


        public ArrayListDataSet e
        {
            get { return new ArrayListDataSet(); }

        }

        public View View
        {
            get
            {
                return view;
            }
            set
            {
                view = value;
                FirePropertyChanged("View");
            }

        }
        int last;

        public int LastSelectedTabIndex
        {
            get
            {
                return last;
            }

        }
        public int SelectedTabIndex
        {
            get
            {
                return selectedTabIndex;
            }
            set
            {


                if (selectedTabIndex != value)
                {
                    last = selectedTabIndex;
                    selectedTabIndex = value;

                    FirePropertyChanged("SelectedTabIndex");
                    FirePropertyChanged("SelectedTab");

                    if (last == -1) FirePropertyChanged("IsLoaded");

                    Dir = selectedTabIndex - last;
                    Settings.LastTab = SelectedTabIndex;
                    //  if(SelectedTabIndex>0 && Tabs.Count>0) View = SelectedTab.View;
                }
            }
        }


        int dir = 0;
        public int Dir
        {
            get { return dir; }
            set
            {
                dir = value;
                FirePropertyChanged("Dir");
            }

        }

        public int Last
        {
            get
            {
                return last;
            }
            set
            {

                last = value;
            }
        }
        public bool BarActive
        {
            get
            {
                return barActive;
            }
            set
            {
                barActive = value;
                FirePropertyChanged("BarActive");
            }
        }


        public ArrayListDataSet Tabs
        {
            get
            {
                if (tabs == null) tabs = new ArrayListDataSet();
                return tabs;
            }
            set
            {
                tabs = value;
                FirePropertyChanged("Tabs");
            }
        }

        public virtual void ClickItem(Item item)
        {

        }






    }





}