using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.MediaCenter.Hosting;
using Microsoft.MediaCenter.UI;
using System.Linq;
using System.Xml.Linq;
using System.Threading;


namespace Playkanaler
{

    public class Tab : VirtualList
    {
        public Tab()
        {
        }

        public Tab(string Title, int indx)
        {
            this.title = Title;
            this.index = indx;
        }
        public Tab(string Title)
        {
            this.title = Title;
        }
        Item[] tepmItems;
        public Tab(string Title, int indx, Item[] itms, Playkanaler.View view)
        {
            this.title = Title;
            this.index = indx;
            tepmItems = itms;

            View = view;

        }
        bool isloaded = false;
        virtual public void Load()
        {
            if (!IsLoaded)
            {
                if (tepmItems == null) tepmItems = new Item[0];
                IsLoaded = true;
                Group g = new Group();
                foreach (Item i in tepmItems) g.Add(i);
                // Groups.Add(g);
                //g.Count = g.Items.Count;
                Add(g);
            }
        }


        int index;
        ArrayListDataSet groups = new ArrayListDataSet();

        string title;
        Playkanaler.View view;




        #region properties


        public virtual void GetMore()
        {

        }
        public virtual void LoadContent()
        {

        }

        public bool IsLoaded
        {
            get
            {
                return isloaded;
            }
            set
            {
                isloaded = value;
                FirePropertyChanged("IsLoaded");
            }

        }

        public View View
        {
            get
            {
                return view;
            }
            set
            {
                view = value;
                FirePropertyChanged("View");
            }

        }
        //public ArrayListDataSet Groups
        //{
        //    get
        //    {
        //        return groups;
        //    }
        //    set
        //    {
        //        groups = value;
        //        FirePropertyChanged("Groups");
        //    }
        //}

        public int Index
        {
            get
            {
                return index;
            }
            set
            {
                index = value;
            }
        }

        public string Title
        {
            get
            {
                return title;
            }
            set
            {
                title = value;
            }
        }

        #endregion




        //public int getNumItems()
        //{
        //    int num = 0;
        //    try
        //    {
        //        foreach (Group g in groups)
        //        {
        //            foreach (Item i in g.Items)
        //            {
        //                num++;
        //            }
        //        }
        //    }
        //    catch (Exception)
        //    {

        //    }


        //    return num;


        //}
        public void setindex()
        {
            int num = 0;
            foreach (Group g in groups)
            {
                foreach (Item i in g)
                {
                    i.Index = num;
                    num++;
                }
            }



        }


    }

    public class GroupTab : Tab
    {

        List<Item> fil;
        string groupby1 = "";
        bool reverse1 = false;
        public GroupTab(string title, Item[] filmer, string groupby, bool reverse)
        {

            Title = title;

            fil = filmer.ToList();
            groupby1 = groupby;
            reverse1 = reverse;

            /*
           var filmr =
                   from film in filmer
                   orderby film.Attributes[groupby]
                   group film by film.Attributes[groupby].ToString() into g
                   select new { genre = g.Key, Movies = g };

          

           if (reverse) filmr.Reverse();
           int i = 1;
           foreach (var g in filmr.Reverse())
           {
               Group g2;
               if(g.genre.ToString()!="")  g2 = new Group(g.genre.ToString());
               else g2= new Group("Oknt");
               foreach (var w in g.Movies)
               {
                   w.Index = i;
                   g2.Items.Add(w);
                   i++;
               }

              this.Groups.Add(g2);

           }
             */

        }
        override public void Load()
        {
            if (!IsLoaded)
            {
                var filmr =
                                   from film in fil
                                   orderby film.Attributes[groupby1]
                                   group film by film.Attributes[groupby1].ToString() into g
                                   select new { genre = g.Key, Movies = g };



                if (reverse1) filmr.Reverse();
                int i = 1;
                foreach (var g in filmr.Reverse())
                {
                    Group g2;
                    if (g.genre.ToString() != "") g2 = new Group(g.genre.ToString());
                    else g2 = new Group("Oknt");
                    foreach (var w in g.Movies)
                    {
                        w.Index = i;
                        g2.Add(w);
                        i++;
                    }
                    //g2.Count = g.Movies.Count();
                    //g2.Count = g2.Items.Count;
                    //this.Groups.Add(g2);
                    Add(g2);
                }
                IsLoaded = true;
            }

        }
    }

    public class FilterTab : Tab
    {
        List<Item> filmer;
        string attribute = "";
        bool reverse = false;
        Group g2 = new Group("");

        public FilterTab(string title, List<Item> filmer, string attribute, bool reverse)
        {
            Title = title;
            View lv = new View("List", "ListItem");
            View = lv;

            this.filmer = filmer;
            this.attribute = attribute;
            this.reverse = reverse;


            List<object> res = new List<object>();
            foreach (Item m in filmer)
            {
                if (m.Attributes[attribute].ToString().Contains(","))
                {
                    foreach (string a in m.Attributes[attribute].ToString().Split(','))
                    {
                        res.Add(a);
                    }
                }
                else if (m.Attributes[attribute].ToString().Contains("|"))
                    foreach (string a in m.Attributes[attribute].ToString().Split('|'))
                    {
                        res.Add(a);
                    }
                else res.Add(m.Attributes[attribute].ToString());
            }
            var filmr =
                    from film in res
                    orderby film
                    group film by film into g
                    select new { genre = g.Key, ffs = g };

            Group g2 = new Group("");
            int it = 0;

            if (reverse) filmr.Reverse();

            foreach (var g in filmr)
            {

                if (g.genre.ToString() != "") g2.Add(new FilterItem(attribute, attribute, g.genre.ToString(), it));
                else g2.Add(new FilterItem(attribute, attribute, "Oknt", it));

                it++;
            }



            Add(g2);
        }
        public override void Load()
        {
            if (!IsLoaded)
            {
                Microsoft.MediaCenter.UI.Application.DeferredInvokeOnWorkerThread(doloading, done, null);


                IsLoaded = true;
            }
        }
        void doloading(object obj)
        {
            Thread.CurrentThread.Priority = ThreadPriority.Lowest;
            List<object> res = new List<object>();
            foreach (Item m in filmer)
            {
                if (m.Attributes[attribute].ToString().Contains(","))
                {
                    foreach (string a in m.Attributes[attribute].ToString().Split(','))
                    {
                        res.Add(a);
                    }
                }
                else if (m.Attributes[attribute].ToString().Contains("|"))
                    foreach (string a in m.Attributes[attribute].ToString().Split('|'))
                    {
                        res.Add(a);
                    }
                if (m.Attributes[attribute].ToString().Contains(";"))
                    foreach (string a in m.Attributes[attribute].ToString().Split(';'))
                    {
                        res.Add(a);
                    }

            }
            var filmr =
                    from film in res
                    orderby film
                    group film by film into g
                    select new { genre = g.Key };


            int it = 0;

            if (reverse) filmr.Reverse();

            foreach (var g in filmr)
            {

                //System.Threading.Thread.Sleep(10);
                //if (g.genre.ToString() != "") g2.Add(new FilterItem(attribute, attribute, g.genre.ToString(), it));
                //else g2.Add(new FilterItem(attribute, attribute, "Oknt", it));


                if (g.genre.ToString() != "") Microsoft.MediaCenter.UI.Application.DeferredInvoke(additem, new FilterItem(attribute, attribute, g.genre.ToString(), it));//                 
                else Microsoft.MediaCenter.UI.Application.DeferredInvoke(additem, new FilterItem(attribute, attribute, "Oknt", it));//
                //it++;
            }
            //g2.Count = filmr.Count();

        }
        void additem(object obj)
        {
            if (!IsDisposed)
            {

                g2.Add((Item)obj);
            }
        }

        void done(object obj)
        {

        }
    }

}